kiss/kiss

1666 lines
56 KiB
Plaintext
Raw Normal View History

2020-01-11 12:35:23 +00:00
#!/bin/sh -ef
# shellcheck source=/dev/null
#
2019-09-11 05:54:45 +00:00
# This is a simple package manager written in POSIX 'sh' for use
2020-02-19 21:46:59 +00:00
# in KISS Linux (https://k1ss.org).
2019-08-19 17:07:50 +00:00
#
2019-09-11 05:54:45 +00:00
# This script runs with '-ef' meaning:
# '-e': Abort on any non-zero exit code.
# '-f': Disable globbing globally.
2019-06-29 20:38:35 +00:00
#
# [1] Warnings related to word splitting and globbing are disabled.
2019-09-11 05:54:45 +00:00
# All word splitting in this script is *safe* and intentional.
2019-06-29 20:38:35 +00:00
#
2020-05-01 20:44:19 +00:00
# REGARDING PORTABILITY
#
# - Anything with a specification should follow it (POSIX, BSD, etc).
# - Anything without a specification which has ONLY a single (widely used)
# implementation will be considered portable (git, curl, etc).
#
# POSIX utilities
# - sh (POSIX)
# - find (POSIX) -type f, -type d, -exec {} [+;], -o, -print, !
# - ls (POSIX) -l, -d
# - sed (POSIX) -n, s/<search>/<replace>/g, /<delete>/d
# - grep (POSIX) -l, -F, -x, -f, -q, -v
# - sort (POSIX) -r, -u, -k
# - tee (POSIX)
# - date (POSIX)
# - mkdir (POSIX) -p
# - rm (POSIX) -f, -r
# - rmdir (POSIX)
# - cp (POSIX) -f, -P, -p, -L, -R
# - mv (POSIX) -f
# - chown (POSIX) -h
# - diff (POSIX) -U
#
# BSD utilities
# - install (BSD, not POSIX) (still portable) -o, -g, -m, -d
#
# Misc
# - su* (sudo, doas, su) (in order, optional)
# - git (downloads from git) (must link to curl)
# - curl (needed by git)
#
# Compiler/libc utilities (depends cc & libc)
# - readelf (optional) (Part of compiler toolchain) (GNU, LLVM or elfutils)
# - strip (optional) (Part of compiler toolchain) (GNU, LLVM or elfutils)
# - ldd (optional) (Part of libc)
2020-05-01 20:44:19 +00:00
#
# Tarball compression
# - tar (as portable as can be) (merely: cf, tf, xf)
2020-05-01 20:44:19 +00:00
# - bzip2 (widely used) -d, -z
# - xz (widely used) -d, -z, -c, -T
# - gzip (widely used) -d, -6
# - zstd (optional) -d, -z, -c
# - unzip (optional)
2020-05-08 21:47:39 +00:00
# - lzma (optional)
# - lzip (optional)
# - sha256 (checksums) (NO standard) (multiple fallbacks)
2020-05-01 20:44:19 +00:00
#
2019-09-11 05:54:45 +00:00
# Dylan Araps.
2019-06-13 14:48:08 +00:00
2019-09-21 17:22:56 +00:00
log() {
# Print a message prettily.
2019-09-21 18:32:03 +00:00
#
2020-01-28 08:19:47 +00:00
# All messages are printed to stderr to allow the user to hide build
# output which is the only thing printed to stdout.
#
# '\033[1;32m' Set text to color '2' and make it bold.
# '\033[m': Reset text formatting.
# '${3:-->}': If the 3rd argument is missing, set prefix to '->'.
# '${2:+\033[1;3Xm}': If the 2nd argument exists, set text style of '$1'.
printf '\033[1;33m%s \033[m%b%s\033[m %s\n' \
2020-01-28 08:19:47 +00:00
"${3:-->}" "${2:+\033[1;36m}" "$1" "$2" >&2
2019-09-21 17:22:56 +00:00
}
2020-04-28 15:36:53 +00:00
war() {
2020-05-07 11:46:50 +00:00
log "$1" "$2" "${3:-WARNING}"
2020-04-28 15:36:53 +00:00
}
2019-06-13 14:48:08 +00:00
die() {
2020-05-07 11:46:50 +00:00
log "$1" "$2" "${3:-ERROR}"
2019-06-13 14:48:08 +00:00
exit 1
}
contains() {
# Check if a "string list" contains a word.
2019-11-29 10:16:48 +00:00
case " $1 " in *" $2 "*) return 0; esac; return 1
}
2020-02-18 19:28:35 +00:00
prompt() {
# Ask the user for some input.
[ "$1" ] && log "$1"
2020-02-18 19:28:35 +00:00
log "Continue?: Press Enter to continue or Ctrl+C to abort here"
# POSIX 'read' has none of the "nice" options like '-n', '-p'
# etc etc. This is the most basic usage of 'read'.
# '_' is used as 'dash' errors when no variable is given to 'read'.
read -r _
2019-09-22 11:35:07 +00:00
}
2020-01-30 07:27:25 +00:00
as_root() {
2020-01-30 12:32:57 +00:00
# Simple function to run a command as root using either 'sudo',
2020-01-31 09:38:52 +00:00
# 'doas' or 'su'. Hurrah for choice.
[ "$uid" = 0 ] || log "Using '${su:-su}' (to become ${user:=root})"
2020-01-30 12:42:29 +00:00
case $su in
*sudo) sudo -E -u "$user" -- "$@" ;;
*doas) doas -u "$user" -- "$@" ;;
*) su -pc "$* <&3" "$user" 3<&0 </dev/tty ;;
2020-01-30 12:42:29 +00:00
esac
2020-01-27 08:06:56 +00:00
}
2020-02-03 09:11:16 +00:00
esc() {
2020-01-28 14:46:29 +00:00
# Escape all required characters in both the search and
# replace portions of two strings for use in a 'sed' call
# as "plain-text".
2020-03-25 11:11:22 +00:00
printf 's/^%s$/%s/' "$(printf %s "$1" | sed 's/[]\/$*.^[]/\\&/g')" \
"$(printf %s "$2" | sed 's/[\/&]/\\&/g')"
2020-01-28 14:46:29 +00:00
}
2020-02-06 11:22:19 +00:00
pop() {
# Remove an item from a "string list". This allows us
# to remove a 'sed' call and reuse this code throughout.
del=$1
2020-03-25 11:11:22 +00:00
shift 2
2020-02-06 11:22:19 +00:00
2020-03-21 11:48:05 +00:00
for i do [ "$i" = "$del" ] || printf %s " $i "; done
2020-02-06 11:22:19 +00:00
}
run_hook() {
2020-04-15 13:13:33 +00:00
[ "${KISS_HOOK:-}" ] || return 0
2020-03-05 15:59:47 +00:00
log "$2" "Running $1 hook"
2020-03-05 15:59:47 +00:00
TYPE=$1 PKG=$2 DEST=$3 . "$KISS_HOOK"
}
decompress() {
case $1 in
2020-05-07 14:25:35 +00:00
*.bz2) bzip2 -d ;;
*.lzma) lzma -dc ;;
2020-05-07 15:17:12 +00:00
*.lz) lzip -dc ;;
2020-05-07 14:25:35 +00:00
*.tar) cat ;;
*.tgz|*.gz) gzip -d ;;
*.xz) xz -dcT 0 ;;
*.zst) zstd -dc ;;
esac < "$1"
}
sh256() {
# There's no standard utility to generate sha256 checksums.
# This is a simple wrapper around sha256sum, sha256, shasum
# and openssl which will use whatever is available.
#
# All utilities must match 'sha256sum' output.
#
# Example: '<checksum> <file>'
[ -e "$1" ] || return 0
read -r hash file <<-EOF
2020-05-09 16:39:27 +00:00
$(sha256sum "$1" ||
sha256 -r "$1" ||
openssl dgst -sha256 -r "$1" ||
shasum -a 256 "$1")
EOF
printf '%s %s\n' "$hash" "${file#\*}"
} 2>/dev/null
2019-06-29 20:38:35 +00:00
pkg_lint() {
2019-09-21 17:22:56 +00:00
log "$1" "Checking repository files"
2019-06-13 14:48:08 +00:00
2020-03-23 09:41:32 +00:00
cd "$(pkg_find "$1")"
read -r _ release 2>/dev/null < version || die "Version file not found"
2019-06-29 20:38:35 +00:00
2020-03-23 09:41:32 +00:00
[ "$release" ] || die "$1" "Release field not found in version file"
2019-09-21 17:22:56 +00:00
[ -f sources ] || die "$1" "Sources file not found"
[ -x build ] || die "$1" "Build file not found or not executable"
[ -s version ] || die "$1" "Version file not found or empty"
2019-06-29 20:38:35 +00:00
2020-03-23 09:41:32 +00:00
[ "$2" ] || [ -f checksums ] ||
die "$1" "Checksums are missing"
2020-05-01 16:26:36 +00:00
case $PWD in "$KISS_ROOT/var/db/kiss/installed"*)
2020-04-28 15:36:53 +00:00
war "$1" "no longer exists in the repositories"
esac
2019-06-18 08:05:15 +00:00
}
pkg_find() {
2019-06-28 21:26:43 +00:00
# Figure out which repository a package belongs to by
# searching for directories matching the package name
2019-06-29 20:38:35 +00:00
# in $KISS_PATH/*.
2020-05-08 15:48:16 +00:00
query=$1 all=$2 what=$3 IFS=:; set --
2019-10-01 19:40:23 +00:00
2020-03-23 10:05:54 +00:00
# Both counts of word-splitting are intentional here.
2020-03-23 09:41:32 +00:00
# Firstly to split the repositories and secondly to
# allow for the query to be a glob.
# shellcheck disable=2086
2020-05-08 15:48:16 +00:00
for path in $KISS_PATH "${what:-$sys_db}"; do
2020-03-23 09:41:32 +00:00
set +f
2020-01-28 21:32:39 +00:00
2020-03-23 09:41:32 +00:00
for path2 in "$path/"$query; do
2020-05-08 15:48:16 +00:00
test "${what:--d}" "$path2" && set -f -- "$@" "$path2"
2020-03-23 09:41:32 +00:00
done
done
2019-06-13 16:40:50 +00:00
2020-04-20 09:14:25 +00:00
unset IFS
2020-03-23 10:05:54 +00:00
2019-06-29 20:38:35 +00:00
# A package may also not be found due to a repository not being
# readable by the current user. Either way, we need to die here.
2019-10-01 19:40:23 +00:00
[ "$1" ] || die "Package '$query' not in any repository"
2019-06-13 16:40:50 +00:00
2019-10-01 19:40:23 +00:00
# Show all search results if called from 'kiss search', else
# print only the first match.
[ "$all" ] && printf '%s\n' "$@" || printf '%s\n' "$1"
2019-06-13 16:40:50 +00:00
}
2019-06-29 20:38:35 +00:00
pkg_list() {
# List installed packages. As the format is files and
# directories, this just involves a simple for loop and
2019-06-29 20:38:35 +00:00
# file read.
# Change directories to the database. This allows us to
2020-04-24 08:04:05 +00:00
# avoid having to 'basename' each path.
2020-03-23 10:05:54 +00:00
cd "$sys_db" 2>/dev/null
2019-06-29 20:38:35 +00:00
# Optional arguments can be passed to check for specific
2020-03-23 10:05:54 +00:00
# packages. If no arguments are passed, list all.
[ "$1" ] || { set +f; set -f -- *; }
2019-06-29 20:38:35 +00:00
2019-09-09 08:17:59 +00:00
# Loop over each package and print its name and version.
2020-03-21 11:48:05 +00:00
for pkg do
[ -d "$pkg" ] || { log "$pkg" "not installed"; return 1; }
2019-06-13 14:48:08 +00:00
2019-09-10 13:56:44 +00:00
read -r version 2>/dev/null < "$pkg/version" || version=null
printf '%s\n' "$pkg $version"
2019-06-29 20:38:35 +00:00
done
2019-06-13 14:48:08 +00:00
}
pkg_cache() {
read -r version release 2>/dev/null < "$(pkg_find "$1")/version"
set +f; set -f -- "$bin_dir/$1#$version-$release.tar."*
tar_file=$1
[ -f "$tar_file" ]
}
2019-06-13 14:48:08 +00:00
pkg_sources() {
2019-06-29 20:38:35 +00:00
# Download any remote package sources. The existence of local
# files is also checked.
2019-09-21 17:22:56 +00:00
log "$1" "Downloading sources"
2019-09-10 07:56:14 +00:00
# Store each downloaded source in a directory named after the
# package it belongs to. This avoid conflicts between two packages
# having a source of the same name.
2019-08-20 10:05:34 +00:00
mkdir -p "$src_dir/$1" && cd "$src_dir/$1"
2019-06-29 20:38:35 +00:00
2020-01-16 21:45:12 +00:00
while read -r src dest || [ "$src" ]; do
2020-02-14 16:06:47 +00:00
# Comment.
if [ -z "${src##\#*}" ]; then :
2019-09-23 06:30:34 +00:00
# Remote source (cached).
2020-02-14 16:06:47 +00:00
elif [ -f "${src##*/}" ]; then
2019-09-23 06:30:34 +00:00
log "$1" "Found cached source '${src##*/}'"
2020-01-16 21:45:12 +00:00
# Remote git repository.
elif [ -z "${src##git+*}" ]; then
# This is a checksums check, skip it.
[ "$2" ] && continue
mkdir -p "$mak_dir/$1/$dest"
2020-02-19 14:11:02 +00:00
# Run in a subshell to keep the variables, path and
# argument list local to each loop iteration.
(
repo_src=${src##git+}
2020-02-19 14:11:02 +00:00
log "$1" "Cloning ${repo_src%[@#]*}"
2020-02-11 15:33:38 +00:00
2020-02-19 14:11:02 +00:00
# Git has no option to clone a repository to a
# specific location so we must do it ourselves
# beforehand.
2020-04-26 06:29:48 +00:00
cd "$mak_dir/$1/$dest" 2>/dev/null || die
2020-02-19 14:28:44 +00:00
# Clear the argument list as we'll be overwriting
# it below based on what kind of checkout we're
# dealing with.
set -- "$repo_src"
2020-02-19 14:11:02 +00:00
# If a branch was given, shallow clone it directly.
# This speeds things up as we don't have to grab
# a lot of unneeded commits.
2020-02-19 14:28:44 +00:00
[ "${src##*@*}" ] ||
2020-02-19 14:11:02 +00:00
set -- -b "${src##*@}" "${repo_src%@*}"
2020-02-19 13:26:34 +00:00
2020-02-19 14:28:44 +00:00
# Maintain compatibility with older versions of
# kiss by shallow cloning all branches. This has
# the added benefit of allowing checkouts of
# specific commits in specific branches.
[ "${src##*#*}" ] ||
set -- --no-single-branch "${repo_src%#*}"
2020-02-19 13:26:34 +00:00
# Always do a shallow clone as we will unshallow it if
# needed later (when a commit is desired).
2020-02-19 14:28:44 +00:00
git clone --depth=1 "$@" .
) || die "$1" "Failed to clone $src"
2020-01-16 21:45:12 +00:00
2019-09-23 06:30:34 +00:00
# Remote source.
elif [ -z "${src##*://*}" ]; then
2020-02-11 15:33:38 +00:00
log "$1" "Downloading $src"
curl "$src" -fLo "${src##*/}" || {
2019-09-23 06:30:34 +00:00
rm -f "${src##*/}"
die "$1" "Failed to download $src"
}
# Local source.
2020-03-22 14:32:05 +00:00
elif [ -f "$(pkg_find "$1")/$src" ]; then
2019-09-23 06:30:34 +00:00
log "$1" "Found local file '$src'"
else
die "$1" "No local file '$src'"
fi
2020-03-22 14:32:05 +00:00
done < "$(pkg_find "$1")/sources"
2019-06-13 14:48:08 +00:00
}
pkg_extract() {
# Extract all source archives to the build directory and copy over
2019-06-29 20:38:35 +00:00
# any local repository files.
2019-09-21 17:22:56 +00:00
log "$1" "Extracting sources"
2019-06-29 20:38:35 +00:00
2019-11-16 19:53:41 +00:00
while read -r src dest || [ "$src" ]; do
2019-09-10 08:20:05 +00:00
mkdir -p "$mak_dir/$1/$dest" && cd "$mak_dir/$1/$dest"
2019-06-29 20:38:35 +00:00
case $src in
2020-01-16 21:45:12 +00:00
# Git repository with supplied commit hash.
git+*\#*)
2020-01-16 21:48:19 +00:00
log "Checking out ${src##*#}"
2020-02-19 14:13:15 +00:00
# A commit was requested, unshallow the repository.
# This will convert it to a regular repository with
# full history.
git fetch --unshallow
# Try to checkout the repository. If we fail here,
# the requested commit doesn't exist.
2020-02-12 07:27:48 +00:00
git -c advice.detachedHead=false checkout "${src##*#}" ||
2020-01-16 21:45:12 +00:00
die "Commit hash ${src##*#} doesn't exist"
;;
2020-02-14 16:08:00 +00:00
# Git repository, comment or blank line.
git+*|\#*|'') continue ;;
2020-01-16 21:45:12 +00:00
# Tarballs of any kind. This is a shell equivalent of
2020-05-08 19:15:16 +00:00
# GNU tar's '--strip-components 1'.
2020-03-17 08:12:43 +00:00
*://*.tar|*://*.tar.??|*://*.tar.???|*://*.tar.????|*://*.tgz)
2020-05-08 19:15:16 +00:00
decompress "$src_dir/$1/${src##*/}" > .ktar
"$tar" xf .ktar ||
die "$1" "Couldn't extract ${src##*/}"
"$tar" tf .ktar | while IFS=/ read -r dir _; do
# Some tarballs contain './' as the top-level directory,
# we need to skip these occurances.
[ -d "${dir#.}" ] || continue
# Move the directory to prevent naming conflicts between
# the child and parent
mv -f "$dir" "$$-$dir"
# First attempt to move all files up a directory level,
# if any files/directories fail (due to mv's lack of
# directory merge capability), simply do the exercise
# again and copy-merge the remaining files/directories.
{
find "$$-$dir/." ! -name . -prune -exec mv -f {} . + ||
find "$$-$dir/." ! -name . -prune -exec cp -fRp {} . +
} 2>/dev/null
# Remove the directory now that all files have been
# transferred out of it. This can't be a simple 'rmdir'
2020-05-08 19:19:06 +00:00
# as we may leave files in here due to above.
rm -rf "$$-$dir"
done
# Clean up after ourselves and remove the temporary tar
# archive we've created. Not needed at all really.
rm -f .ktar
;;
2019-09-23 06:30:34 +00:00
# Zip archives.
2020-04-14 14:52:39 +00:00
*://*.zip)
unzip "$src_dir/$1/${src##*/}" ||
die "$1" "Couldn't extract ${src##*/}"
;;
*)
# Local file.
2020-03-22 14:32:05 +00:00
if [ -f "$(pkg_find "$1")/$src" ]; then
cp -f "$(pkg_find "$1")/$src" .
2019-09-23 06:30:34 +00:00
# Remote file.
elif [ -f "$src_dir/$1/${src##*/}" ]; then
cp -f "$src_dir/$1/${src##*/}" .
else
die "$1" "Local file $src not found"
fi
;;
esac
2020-03-22 14:32:05 +00:00
done < "$(pkg_find "$1")/sources"
2019-06-13 14:48:08 +00:00
}
2019-06-29 20:38:35 +00:00
pkg_depends() {
2019-09-15 06:31:57 +00:00
# Resolve all dependencies and generate an ordered list.
2019-06-29 20:38:35 +00:00
# This does a depth-first search. The deepest dependencies are
# listed first and then the parents in reverse order.
contains "$deps" "$1" || {
2019-09-15 06:39:39 +00:00
# Filter out non-explicit, aleady installed dependencies.
2019-09-16 06:26:15 +00:00
# Only filter installed if called from 'pkg_build()'.
2019-09-16 08:57:35 +00:00
[ "$pkg_build" ] && [ -z "$2" ] &&
(pkg_list "$1" >/dev/null) && return
2019-09-15 06:15:32 +00:00
2019-09-16 06:26:15 +00:00
# Recurse through the dependencies of the child packages.
2019-11-16 19:53:41 +00:00
while read -r dep _ || [ "$dep" ]; do
2019-09-14 07:23:58 +00:00
[ "${dep##\#*}" ] && pkg_depends "$dep"
2020-03-21 11:44:43 +00:00
done 2>/dev/null < "$(pkg_find "$1")/depends" ||:
# After child dependencies are added to the list,
# add the package which depends on them.
2019-09-15 06:31:57 +00:00
[ "$2" = explicit ] || deps="$deps $1 "
}
2019-06-29 20:38:35 +00:00
}
pkg_order() {
# Order a list of packages based on dependence and
# take into account pre-built tarballs if this is
# to be called from 'kiss i'.
2020-02-10 20:04:34 +00:00
order=; redro=; deps=
2020-03-21 11:48:05 +00:00
for pkg do case $pkg in
2020-03-21 11:35:43 +00:00
*.tar.*) deps="$deps $pkg " ;;
*) pkg_depends "$pkg" raw
2020-03-21 11:48:05 +00:00
esac done
# Filter the list, only keeping explicit packages.
# The purpose of these two loops is to order the
# argument list based on dependence.
2020-04-20 06:29:53 +00:00
for pkg in $deps; do contains "$*" "$pkg" && {
2020-03-21 11:35:43 +00:00
order="$order $pkg "
redro=" $pkg $redro"
2020-03-21 11:48:05 +00:00
} done
deps=
}
2019-06-13 14:48:08 +00:00
pkg_strip() {
2019-06-29 20:38:35 +00:00
# Strip package binaries and libraries. This saves space on the
2020-04-24 08:04:05 +00:00
# system as well as on the tarballs we ship for installation.
2019-11-09 09:45:23 +00:00
[ -f "$mak_dir/$pkg/nostrip" ] && return
2019-06-13 14:48:08 +00:00
2019-09-21 17:22:56 +00:00
log "$1" "Stripping binaries and libraries"
2019-06-29 20:38:35 +00:00
command -v strip >/dev/null 2>&1 || {
war "strip not found, skipping binary stripping"
return 0
}
command -v readelf >/dev/null 2>&1 || {
war "readelf not found, skipping binary stripping"
return 0
}
2019-08-30 17:09:55 +00:00
# Strip only files matching the below ELF types.
2020-01-14 18:36:40 +00:00
# NOTE: 'readelf' is used in place of 'file' as
# it allows us to remove 'file' from the
# core repositories altogether.
2019-08-30 16:48:00 +00:00
find "$pkg_dir/$1" -type f | while read -r file; do
2020-03-25 11:11:22 +00:00
case $(readelf -h "$file") in
2019-11-29 10:16:48 +00:00
*" DYN "*) strip_opt=unneeded ;;
*" EXEC "*) strip_opt=all ;;
*" REL "*) strip_opt=debug ;;
2019-09-16 06:45:25 +00:00
*) continue
2019-08-30 16:48:00 +00:00
esac
2020-04-25 05:59:44 +00:00
strip "--strip-$strip_opt" "$file" 2>/dev/null
2020-03-26 10:45:22 +00:00
done 2>/dev/null ||:
2019-06-13 14:48:08 +00:00
}
pkg_fixdeps() {
# Dynamically look for missing runtime dependencies by checking
# each binary and library with 'ldd'. This catches any extra
# libraries and or dependencies pulled in by the package's
# build suite.
2019-09-21 17:22:56 +00:00
log "$1" "Checking for missing dependencies"
command -v ldd >/dev/null 2>&1 || {
war "ldd not found, skipping dependency fixer"
return 0
}
# Go to the directory containing the built package to
# simplify path building.
cd "$pkg_dir/$1/$pkg_db/$1"
2020-01-12 17:55:12 +00:00
# Generate a list of all installed manifests.
2020-03-23 10:40:38 +00:00
set +f; set -f -- "$sys_db/"*/manifest
2020-04-15 08:58:01 +00:00
# Make a copy of the depends file if it exists to have a
# reference to 'diff' against.
if [ -f depends ]; then
cp -f depends "$mak_dir/d"
dep_file=$mak_dir/d
else
dep_file=/dev/null
fi
2020-01-12 17:55:12 +00:00
2019-09-10 09:01:00 +00:00
# Get a list of binaries and libraries, false files
# will be found, however it's faster to get 'ldd' to check
# them anyway than to filter them out.
2020-03-23 10:40:38 +00:00
find "$pkg_dir/${PWD##*/}/" -type f 2>/dev/null |
2020-01-12 17:55:12 +00:00
while read -r file; do
# Run 'ldd' on the file and parse each line. The code
# then checks to see which packages own the linked
# libraries and it prints the result.
ldd "$file" 2>/dev/null | while read -r dep; do
# Skip lines containing 'ldd'.
[ "${dep##*ldd*}" ] || continue
# Extract the file path from 'ldd' output.
2020-05-09 15:18:52 +00:00
dep=${dep#* => } dep=${dep% *} old_PWD=$PWD
# False positive (we need to modify PWD).
# shellcheck disable=2030
cd -P "${dep%/*}" 2>/dev/null || PWD=${1%/*}
# 'ls' is used to obtain the target of the symlink.
#
# This is fine _despite_ the usual gaggle about 'ls' and its
# use in scripting. The POSIX specification states that the
# link target must be the exact contents of the link.
#
# The specification:
#
# > If the file is a symbolic link and the -L option is not
# specified, this information shall be about the link
# itself and the <pathname> field shall be of the form:
#
# > "%s -> %s", <pathname of link>, <contents of link>
lso=$(ls -ld "$PWD/${dep##*/}" 2>/dev/null) &&
case $lso in *' -> '*)
lso=${lso##*" -> "} dep=$PWD/${lso##*/}
esac
# We need to go back to where we came from as the old PWD
# stores the name of the current package.
cd "$old_PWD"
# Figure out which package owns the file.
2020-03-25 15:36:13 +00:00
own=$("$grep" -lFx "${dep##$KISS_ROOT}" "$@")
2020-05-09 15:18:52 +00:00
own=${own%/*} own=${own##*/}
2020-03-25 15:36:13 +00:00
# Skip listing these packages as dependencies.
case $own in musl|gcc|llvm|"${PWD##*/}"|"") continue; esac
2020-03-25 15:36:13 +00:00
printf '%s\n' "$own"
done ||:
2020-04-15 08:58:01 +00:00
done >> depends
# Remove duplicate entries from the new depends file.
# This removes duplicate lines looking *only* at the
# first column.
sort -uk1,1 -o depends depends 2>/dev/null ||:
2020-03-08 22:14:06 +00:00
# Display a 'diff' of the new dependencies against the old ones.
diff -U 3 "$dep_file" depends ||:
# Remove the package's depends file if it's empty.
[ -s depends ] || rm -f depends
}
2019-06-29 20:38:35 +00:00
pkg_manifest() (
# Generate the package's manifest file. This is a list of each file
# and directory inside the package. The file is used when uninstalling
# packages, checking for package conflicts and for general debugging.
2019-09-21 17:22:56 +00:00
log "$1" "Generating manifest"
2019-06-30 08:35:54 +00:00
2020-02-07 11:27:45 +00:00
# This function runs as a sub-shell to avoid having to 'cd' back to the
2019-06-29 20:38:35 +00:00
# prior directory before being able to continue.
cd "${2:-$pkg_dir}/$1"
2019-06-29 20:38:35 +00:00
2019-09-21 16:03:11 +00:00
# find: Print all files and directories and append '/' to directories.
# sort: Sort the output in *reverse*. Directories appear *after* their
# contents.
# sed: Remove the first character in each line (./dir -> /dir) and
# remove all lines which only contain '.'.
find . -type d -exec printf '%s/\n' {} + -o -print |
sort -r | sed '/^\.\/$/d;ss.ss' > "${2:-$pkg_dir}/$1/$pkg_db/$1/manifest"
2019-06-29 20:38:35 +00:00
)
2019-06-13 14:48:08 +00:00
2020-02-05 08:56:25 +00:00
pkg_etcsums() (
# Generate checksums for each configuration file in the package's
# /etc/ directory for use in "smart" handling of these files.
log "$1" "Generating etcsums"
2020-02-07 11:27:45 +00:00
# This function runs as a sub-shell to avoid having to 'cd' back to the
2020-02-05 08:56:25 +00:00
# prior directory before being able to continue.
cd "$pkg_dir/$1/etc" 2>/dev/null || return 0; cd ..
2020-02-05 08:56:25 +00:00
find etc -type f | while read -r line; do
sh256 "$line"
done > "$pkg_dir/$1/$pkg_db/$1/etcsums"
2020-02-05 08:56:25 +00:00
)
kiss: Various portability fixes. - Added POSIX shell implementation of the 'readlink' utility for use _only_ when the 'readlink' utility is not available. - Made tar usage more portable. All that is left now is the removal of --strip-components 1 for full (presumed) portability. - Swapped from sha256sum to shasum as it's more portable. This is still not a full solution. Here's a checklist of where we currently are: POSIX Core utilities (depends coreutils) - [x] sh (POSIX) - [x] find (POSIX) -type f, -type d, -exec {} [+;], -o, -print, ! - [x] ls (POSIX) -l, -d - [x] sed (POSIX) -n, s/<search>/<replace>/g, /<delete>/d - [x] grep (POSIX) -l, -F, -x, -f, -q, -v - [x] sort (POSIX) -r, -u, -k - [x] tee (POSIX) - [x] date (POSIX) - [x] mkdir (POSIX) -p - [x] rm (POSIX) -f, -r - [x] rmdir (POSIX) - [x] cp (POSIX) -f, -P, -p, -L, -R - [x] mv (POSIX) -f - [x] chown (POSIX) -h - [x] diff (POSIX) -U BSD utilities - [x] install (BSD, not POSIX) (still portable) -o, -g, -m, -d Misc - [x] readlink (NOT POSIX) (fallback shell implementation) - [x] su* (sudo, doas, su) (in order, optional) - [x] git (downloads from git) (must link to curl) Compiler/libc utilities (depends cc & libc) - [x] readelf (Part of compiler toolchain) (GNU, LLVM or elfutils) - [x] strip (Part of compiler toolchain) (GNU, LLVM or elfutils) - [x] ldd (Part of libc) Tarball compression - [ ] tar (must have --strip-components) (busybox, GNU, libarchive)) - [x] bzip2 (widely used) -d, -z - [x] xz (widely used) -d, -z, -c, -T - [x] gzip (widely used) -d, -6 - [x] zstd (optional) -d, -z, -c - [x] unzip (optional) - [ ] shasum (checksums) (NO standard. Portable across Linux/BSD)
2020-04-30 16:38:37 +00:00
pkg_tar() (
2020-04-24 08:04:05 +00:00
# Create a tarball from the built package's files.
# This tarball also contains the package's database entry.
log "$1" "Creating tarball"
2019-06-29 20:38:35 +00:00
# Read the version information to name the package.
read -r version release < "$(pkg_find "$1")/version"
2019-06-29 20:38:35 +00:00
kiss: Various portability fixes. - Added POSIX shell implementation of the 'readlink' utility for use _only_ when the 'readlink' utility is not available. - Made tar usage more portable. All that is left now is the removal of --strip-components 1 for full (presumed) portability. - Swapped from sha256sum to shasum as it's more portable. This is still not a full solution. Here's a checklist of where we currently are: POSIX Core utilities (depends coreutils) - [x] sh (POSIX) - [x] find (POSIX) -type f, -type d, -exec {} [+;], -o, -print, ! - [x] ls (POSIX) -l, -d - [x] sed (POSIX) -n, s/<search>/<replace>/g, /<delete>/d - [x] grep (POSIX) -l, -F, -x, -f, -q, -v - [x] sort (POSIX) -r, -u, -k - [x] tee (POSIX) - [x] date (POSIX) - [x] mkdir (POSIX) -p - [x] rm (POSIX) -f, -r - [x] rmdir (POSIX) - [x] cp (POSIX) -f, -P, -p, -L, -R - [x] mv (POSIX) -f - [x] chown (POSIX) -h - [x] diff (POSIX) -U BSD utilities - [x] install (BSD, not POSIX) (still portable) -o, -g, -m, -d Misc - [x] readlink (NOT POSIX) (fallback shell implementation) - [x] su* (sudo, doas, su) (in order, optional) - [x] git (downloads from git) (must link to curl) Compiler/libc utilities (depends cc & libc) - [x] readelf (Part of compiler toolchain) (GNU, LLVM or elfutils) - [x] strip (Part of compiler toolchain) (GNU, LLVM or elfutils) - [x] ldd (Part of libc) Tarball compression - [ ] tar (must have --strip-components) (busybox, GNU, libarchive)) - [x] bzip2 (widely used) -d, -z - [x] xz (widely used) -d, -z, -c, -T - [x] gzip (widely used) -d, -6 - [x] zstd (optional) -d, -z, -c - [x] unzip (optional) - [ ] shasum (checksums) (NO standard. Portable across Linux/BSD)
2020-04-30 16:38:37 +00:00
# Use 'cd' to avoid needing tar's '-C' flag which may not
# be portable across implementations.
cd "$pkg_dir/$1"
2020-04-24 08:04:05 +00:00
# Create a tarball from the contents of the built package.
kiss: Various portability fixes. - Added POSIX shell implementation of the 'readlink' utility for use _only_ when the 'readlink' utility is not available. - Made tar usage more portable. All that is left now is the removal of --strip-components 1 for full (presumed) portability. - Swapped from sha256sum to shasum as it's more portable. This is still not a full solution. Here's a checklist of where we currently are: POSIX Core utilities (depends coreutils) - [x] sh (POSIX) - [x] find (POSIX) -type f, -type d, -exec {} [+;], -o, -print, ! - [x] ls (POSIX) -l, -d - [x] sed (POSIX) -n, s/<search>/<replace>/g, /<delete>/d - [x] grep (POSIX) -l, -F, -x, -f, -q, -v - [x] sort (POSIX) -r, -u, -k - [x] tee (POSIX) - [x] date (POSIX) - [x] mkdir (POSIX) -p - [x] rm (POSIX) -f, -r - [x] rmdir (POSIX) - [x] cp (POSIX) -f, -P, -p, -L, -R - [x] mv (POSIX) -f - [x] chown (POSIX) -h - [x] diff (POSIX) -U BSD utilities - [x] install (BSD, not POSIX) (still portable) -o, -g, -m, -d Misc - [x] readlink (NOT POSIX) (fallback shell implementation) - [x] su* (sudo, doas, su) (in order, optional) - [x] git (downloads from git) (must link to curl) Compiler/libc utilities (depends cc & libc) - [x] readelf (Part of compiler toolchain) (GNU, LLVM or elfutils) - [x] strip (Part of compiler toolchain) (GNU, LLVM or elfutils) - [x] ldd (Part of libc) Tarball compression - [ ] tar (must have --strip-components) (busybox, GNU, libarchive)) - [x] bzip2 (widely used) -d, -z - [x] xz (widely used) -d, -z, -c, -T - [x] gzip (widely used) -d, -6 - [x] zstd (optional) -d, -z, -c - [x] unzip (optional) - [ ] shasum (checksums) (NO standard. Portable across Linux/BSD)
2020-04-30 16:38:37 +00:00
"$tar" cf - . | case ${KISS_COMPRESS:=gz} in
bz2) bzip2 -z ;;
gz) gzip -6 ;;
2020-05-07 13:25:53 +00:00
lzma) lzma -z ;;
2020-05-07 15:17:12 +00:00
lz) lzip -z ;;
xz) xz -zT 0 ;;
zst) zstd -z ;;
2020-03-23 11:04:45 +00:00
esac > "$bin_dir/$1#$version-$release.tar.${KISS_COMPRESS:=gz}"
2019-06-29 20:38:35 +00:00
2020-04-24 08:04:05 +00:00
log "$1" "Successfully created tarball"
kiss: Various portability fixes. - Added POSIX shell implementation of the 'readlink' utility for use _only_ when the 'readlink' utility is not available. - Made tar usage more portable. All that is left now is the removal of --strip-components 1 for full (presumed) portability. - Swapped from sha256sum to shasum as it's more portable. This is still not a full solution. Here's a checklist of where we currently are: POSIX Core utilities (depends coreutils) - [x] sh (POSIX) - [x] find (POSIX) -type f, -type d, -exec {} [+;], -o, -print, ! - [x] ls (POSIX) -l, -d - [x] sed (POSIX) -n, s/<search>/<replace>/g, /<delete>/d - [x] grep (POSIX) -l, -F, -x, -f, -q, -v - [x] sort (POSIX) -r, -u, -k - [x] tee (POSIX) - [x] date (POSIX) - [x] mkdir (POSIX) -p - [x] rm (POSIX) -f, -r - [x] rmdir (POSIX) - [x] cp (POSIX) -f, -P, -p, -L, -R - [x] mv (POSIX) -f - [x] chown (POSIX) -h - [x] diff (POSIX) -U BSD utilities - [x] install (BSD, not POSIX) (still portable) -o, -g, -m, -d Misc - [x] readlink (NOT POSIX) (fallback shell implementation) - [x] su* (sudo, doas, su) (in order, optional) - [x] git (downloads from git) (must link to curl) Compiler/libc utilities (depends cc & libc) - [x] readelf (Part of compiler toolchain) (GNU, LLVM or elfutils) - [x] strip (Part of compiler toolchain) (GNU, LLVM or elfutils) - [x] ldd (Part of libc) Tarball compression - [ ] tar (must have --strip-components) (busybox, GNU, libarchive)) - [x] bzip2 (widely used) -d, -z - [x] xz (widely used) -d, -z, -c, -T - [x] gzip (widely used) -d, -6 - [x] zstd (optional) -d, -z, -c - [x] unzip (optional) - [ ] shasum (checksums) (NO standard. Portable across Linux/BSD)
2020-04-30 16:38:37 +00:00
)
2019-06-13 14:48:08 +00:00
2019-06-29 20:38:35 +00:00
pkg_build() {
2020-04-24 08:04:05 +00:00
# Build packages and turn them into packaged tarballs. This function
2019-06-29 20:38:35 +00:00
# also checks checksums, downloads sources and ensure all dependencies
# are installed.
2019-09-16 08:57:35 +00:00
pkg_build=1
2019-06-17 07:18:36 +00:00
2019-09-13 18:25:33 +00:00
log "Resolving dependencies"
2019-09-13 21:20:33 +00:00
2020-03-21 11:48:05 +00:00
for pkg do contains "$explicit" "$pkg" || {
pkg_depends "$pkg" explicit
2019-09-13 18:43:23 +00:00
2020-03-21 11:48:05 +00:00
# Mark packages passed on the command-line
# separately from those detected as dependencies.
explicit="$explicit $pkg "
} done
2019-09-13 18:25:33 +00:00
2020-01-11 12:07:21 +00:00
[ "$pkg_update" ] || explicit_build=$explicit
2019-09-13 20:52:15 +00:00
2019-09-13 18:30:16 +00:00
# If an explicit package is a dependency of another explicit
# package, remove it from the explicit list as it needs to be
# installed as a dependency.
2020-02-06 11:22:19 +00:00
# shellcheck disable=2086
2020-03-25 11:11:22 +00:00
for pkg do contains "$deps" "$pkg" &&
explicit=$(pop "$pkg" from $explicit)
2019-09-13 18:25:33 +00:00
done
2019-09-20 14:54:12 +00:00
# See [1] at top of script.
# shellcheck disable=2046,2086
2019-09-15 06:15:32 +00:00
set -- $deps $explicit
2019-08-19 17:15:50 +00:00
log "Building: $*"
2019-07-11 06:14:17 +00:00
# Only ask for confirmation if more than one package needs to be built.
2020-02-18 19:28:35 +00:00
[ $# -gt 1 ] || [ "$pkg_update" ] && prompt
2019-07-11 06:14:17 +00:00
2020-03-26 12:53:03 +00:00
for pkg do pkg_lint "$pkg"; done
2020-04-24 08:04:05 +00:00
log "Checking for pre-built dependencies"
# Install any pre-built dependencies if they exist in the binary
# directory and are up to date.
2020-03-21 11:54:48 +00:00
for pkg do ! contains "$explicit_build" "$pkg" && pkg_cache "$pkg" && {
log "$pkg" "Found pre-built binary, installing"
(KISS_FORCE=1 args i "$tar_file")
# Remove the now installed package from the build list.
# See [1] at top of script.
# shellcheck disable=2046,2086
2020-03-25 11:11:22 +00:00
set -- $(pop "$pkg" from "$@")
2020-03-21 11:54:48 +00:00
} done
2019-06-29 20:38:35 +00:00
2020-03-21 11:48:05 +00:00
for pkg do pkg_sources "$pkg"; done
2019-09-16 06:26:15 +00:00
2020-02-08 18:36:58 +00:00
pkg_verify "$@"
2020-04-29 13:22:57 +00:00
log "$pkg" "Verified all checksums"
2019-06-13 14:48:08 +00:00
2019-07-03 13:35:14 +00:00
# Finally build and create tarballs for all passed packages and
# dependencies.
2020-03-21 11:48:05 +00:00
for pkg do
2020-01-03 07:10:41 +00:00
log "$pkg" "Building package ($((in = in + 1))/$#)"
2019-09-16 07:37:50 +00:00
pkg_extract "$pkg"
repo_dir=$(pkg_find "$pkg")
2019-06-17 07:18:36 +00:00
2019-06-29 20:38:35 +00:00
# Install built packages to a directory under the package name
# to avoid collisions with other packages.
2020-03-26 12:53:03 +00:00
mkdir -p "$pkg_dir/$pkg/$pkg_db" && cd "$mak_dir/$pkg"
2019-09-01 11:50:15 +00:00
log "$pkg" "Starting build"
2020-03-05 15:59:47 +00:00
run_hook pre-build "$pkg" "$pkg_dir/$pkg"
2020-01-28 08:08:15 +00:00
# Call the build script, log the output to the terminal
# and to a file. There's no PIPEFAIL in POSIX shelll so
# we must resort to tricks like killing the script ourselves.
{ "$repo_dir/build" "$pkg_dir/$pkg" 2>&1 || {
2020-01-28 08:08:15 +00:00
log "$pkg" "Build failed"
log "$pkg" "Log stored to $log_dir/$pkg-$time-$pid"
2020-03-05 15:59:47 +00:00
run_hook build-fail "$pkg" "$pkg_dir/$pkg"
2020-01-28 08:08:15 +00:00
pkg_clean
kill 0
2020-02-10 17:36:24 +00:00
} } | tee "$log_dir/$pkg-$time-$pid"
2020-01-28 08:08:15 +00:00
# Delete the log file if the build succeeded to prevent
# the directory from filling very quickly with useless logs.
2020-02-08 08:55:58 +00:00
[ "$KISS_KEEPLOG" = 1 ] || rm -f "$log_dir/$pkg-$time-$pid"
2019-06-29 20:38:35 +00:00
# Copy the repository files to the package directory.
# This acts as the database entry.
2019-10-22 08:54:04 +00:00
cp -LRf "$repo_dir" "$pkg_dir/$pkg/$pkg_db/"
2019-06-29 20:38:35 +00:00
# We never ever want this. Let's end the endless conflicts
# and remove it. This will be the only exception for a
# specific removal of this kind.
rm -f "$pkg_dir/$pkg/usr/lib/charset.alias"
2019-09-21 17:22:56 +00:00
log "$pkg" "Successfully built package"
2020-03-05 15:59:47 +00:00
run_hook post-build "$pkg" "$pkg_dir/$pkg"
2019-06-29 20:38:35 +00:00
# Create the manifest file early and make it empty.
2020-02-19 22:37:46 +00:00
# This ensures that the manifest is added to the manifest.
2019-07-19 22:14:46 +00:00
: > "$pkg_dir/$pkg/$pkg_db/$pkg/manifest"
2019-06-26 16:27:36 +00:00
2020-02-05 08:56:25 +00:00
# If the package contains '/etc', add a file called
# 'etcsums' to the manifest. See comment directly above.
[ -d "$pkg_dir/$pkg/etc" ] &&
: > "$pkg_dir/$pkg/$pkg_db/$pkg/etcsums"
pkg_strip "$pkg"
pkg_fixdeps "$pkg"
pkg_manifest "$pkg"
pkg_etcsums "$pkg"
pkg_tar "$pkg"
2019-06-26 16:27:36 +00:00
# Install only dependencies of passed packages.
2019-08-24 09:10:15 +00:00
# Skip this check if this is a package update.
contains "$explicit" "$pkg" && [ -z "$pkg_update" ] && continue
2019-08-24 09:10:15 +00:00
2019-09-21 17:22:56 +00:00
log "$pkg" "Needed as a dependency or has an update, installing"
2020-01-27 09:10:53 +00:00
2020-01-30 07:27:25 +00:00
(KISS_FORCE=1 args i "$pkg")
done
2019-06-29 20:38:35 +00:00
2019-08-24 09:18:08 +00:00
# End here as this was a system update and all packages have been installed.
[ "$pkg_update" ] && return
2019-08-19 17:15:50 +00:00
log "Successfully built package(s)"
# Turn the explicit packages into a 'list'.
2019-09-20 14:54:12 +00:00
# See [1] at top of script.
# shellcheck disable=2046,2086
2019-09-13 18:09:25 +00:00
set -- $explicit
# Only ask for confirmation if more than one package needs to be installed.
[ $# -gt 1 ] && prompt "Install built packages? [$*]" && {
args i "$@"
return
}
2019-09-22 11:35:07 +00:00
log "Run 'kiss i $*' to install the package(s)"
2019-06-29 20:38:35 +00:00
}
pkg_checksums() {
# Generate checksums for packages.
2019-11-16 19:53:41 +00:00
while read -r src _ || [ "$src" ]; do
2020-02-18 19:31:53 +00:00
# Comment.
if [ -z "${src##\#*}" ]; then
continue
2019-09-11 07:03:35 +00:00
# File is local to the package.
2020-03-23 11:04:45 +00:00
elif [ -f "$(pkg_find "$1")/$src" ]; then
src_path=$(pkg_find "$1")/${src%/*}
2019-09-11 07:03:35 +00:00
# File is remote and was downloaded.
elif [ -f "$src_dir/$1/${src##*/}" ]; then
src_path=$src_dir/$1
2020-01-18 08:59:40 +00:00
# File is a git repository.
2020-01-16 21:45:12 +00:00
elif [ -z "${src##git+*}" ]; then
2020-01-18 09:28:50 +00:00
printf 'git %s\n' "$src"
2020-01-16 21:45:12 +00:00
continue
2019-09-11 07:03:35 +00:00
# Die here if source for some reason, doesn't exist.
else
2019-09-21 17:22:56 +00:00
die "$1" "Couldn't find source '$src'"
2019-09-11 07:03:35 +00:00
fi
2020-04-30 16:57:38 +00:00
# An easy way to get 'sha256sum' to print with the 'basename'
2019-09-11 07:03:35 +00:00
# of files is to 'cd' to the file's directory beforehand.
(cd "$src_path" && sh256 "${src##*/}") ||
2019-09-21 17:22:56 +00:00
die "$1" "Failed to generate checksums"
2020-03-23 11:04:45 +00:00
done < "$(pkg_find "$1")/sources"
2019-06-29 20:38:35 +00:00
}
2020-02-08 18:36:58 +00:00
pkg_verify() {
# Verify all package checksums. This is achieved by generating
# a new set of checksums and then comparing those with the old
# set.
2020-04-30 13:59:25 +00:00
for pkg do pkg_checksums "$pkg" | diff - "$(pkg_find "$pkg")/checksums" || {
2020-03-21 11:54:48 +00:00
log "$pkg" "Checksum mismatch"
2020-02-08 18:36:58 +00:00
2020-03-21 11:54:48 +00:00
# Instead of dying above, log it to the terminal. Also define a
# variable so we *can* die after all checksum files have been
# checked.
mismatch="$mismatch$pkg "
} done
2020-02-08 18:36:58 +00:00
[ -z "$mismatch" ] || die "Checksum mismatch with: ${mismatch% }"
}
2019-06-29 20:38:35 +00:00
pkg_conflicts() {
# Check to see if a package conflicts with another.
log "$1" "Checking for package conflicts"
2019-06-29 20:38:35 +00:00
2019-11-21 00:45:52 +00:00
# Filter the tarball's manifest and select only files
2020-01-14 18:36:40 +00:00
# and any files they resolve to on the filesystem
2019-11-21 00:45:52 +00:00
# (/bin/ls -> /usr/bin/ls).
while read -r file; do
2019-11-21 00:45:52 +00:00
case $file in */) continue; esac
2020-05-09 15:21:13 +00:00
# False positive.
# shellcheck disable=2031
2020-05-09 15:18:52 +00:00
old_PWD=$PWD file=$KISS_ROOT/${file#/}
# Attempt to resolve symlinks by using 'cd'.
# If this fails, fallback to the file's parent
# directory.
cd -P "${file%/*}" 2>/dev/null || PWD=${file%/*}
printf '%s\n' "$PWD/${file##*/}"
cd "$old_PWD"
2020-04-14 14:44:05 +00:00
done < "$tar_dir/$1/$pkg_db/$1/manifest" > "$cac_dir/$pid-m"
2020-01-06 05:49:52 +00:00
2020-03-25 15:14:44 +00:00
[ -s "$cac_dir/$pid-m" ] || return 0
p_name=$1
2020-01-06 05:49:52 +00:00
2020-02-06 11:22:19 +00:00
# Generate a list of all installed package manifests
# and remove the current package from the list.
# shellcheck disable=2046,2086
2020-03-25 15:14:44 +00:00
set -- $(set +f; pop "$sys_db/$1/manifest" from "$sys_db"/*/manifest)
2020-01-28 15:00:29 +00:00
2020-05-06 19:31:54 +00:00
# Store the list of found conflicts in a file as we'll be using the
# information multiple times. Storing things in the cache dir allows
# us to be lazy as they'll be automatically removed on script end.
"$grep" -Fxf "$cac_dir/$pid-m" -- "$@" > "$cac_dir/$pid-c" ||:
2020-02-10 20:04:34 +00:00
# Enable alternatives automatically if it is safe to do so.
# This checks to see that the package that is about to be installed
# doesn't overwrite anything it shouldn't in '/var/db/kiss/installed'.
2020-05-06 19:31:54 +00:00
"$grep" -q ":/var/db/kiss/installed/" "$cac_dir/$pid-c" || choice_auto=1
2020-01-28 16:23:42 +00:00
2020-01-06 05:49:52 +00:00
# Use 'grep' to list matching lines between the to
# be installed package's manifest and the above filtered
# list.
2020-02-10 20:04:34 +00:00
if [ "$KISS_CHOICE" != 0 ] && [ "$choice_auto" = 1 ]; then
2020-01-28 12:07:08 +00:00
# This is a novel way of offering an "alternatives" system.
# It is entirely dynamic and all "choices" are created and
# destroyed on the fly.
#
# When a conflict is found between two packages, the file
# is moved to a directory called "choices" and its name
# changed to store its parent package and its intended
# location.
#
# The package's manifest is then updated to reflect this
# new location.
#
# The 'kiss choices' command parses this directory and
# offers you the CHOICE of *swapping* entries in this
# directory for those on the filesystem.
#
# The choices command does the same thing we do here,
# it rewrites manifests and moves files around to make
# this work.
#
# Pretty nifty huh?
2020-03-11 17:36:31 +00:00
while IFS=: read -r _ con; do
printf '%s\n' "Found conflict $con"
2020-01-28 12:07:08 +00:00
# Create the "choices" directory inside of the tarball.
# This directory will store the conflicting file.
mkdir -p "$tar_dir/$p_name/${cho_dir:=var/db/kiss/choices}"
# Construct the file name of the "db" entry of the
# conflicting file. (pkg_name>usr>bin>ls)
2020-01-28 22:41:45 +00:00
con_name=$(printf %s "$con" | sed 's|/|>|g')
2020-01-28 12:07:08 +00:00
# Move the conflicting file to the choices directory
# and name it according to the format above.
2020-01-28 12:13:26 +00:00
mv -f "$tar_dir/$p_name/$con" \
2020-02-11 10:04:44 +00:00
"$tar_dir/$p_name/$cho_dir/$p_name$con_name" 2>/dev/null || {
log "File must be in ${con%/*} and not a symlink to it"
log "This usually occurs when a binary is installed to"
log "/sbin instead of /usr/bin (example)"
log "Before this package can be used as an alternative,"
log "this must be fixed in $p_name. Contact the maintainer"
2020-05-07 11:46:50 +00:00
die "by finding their details via 'kiss-maintainer'" "" "!>"
2020-02-11 10:04:44 +00:00
}
2020-05-06 19:31:54 +00:00
done < "$cac_dir/$pid-c"
2020-02-06 12:24:21 +00:00
# Rewrite the package's manifest to update its location
# to its new spot (and name) in the choices directory.
pkg_manifest "$p_name" "$tar_dir" 2>/dev/null
2020-05-06 19:31:54 +00:00
elif [ -s "$cac_dir/$pid-c" ]; then
2020-02-06 12:24:21 +00:00
log "Package '$p_name' conflicts with another package" "" "!>"
log "Run 'KISS_CHOICE=1 kiss i $p_name' to add conflicts" "" "!>"
2020-05-07 11:46:50 +00:00
die "as alternatives." "" "!>"
2020-01-28 15:00:29 +00:00
fi
2019-06-13 14:48:08 +00:00
}
2020-01-28 13:07:11 +00:00
pkg_swap() {
# Swap between package alternatives.
2020-01-28 13:07:11 +00:00
pkg_list "$1" >/dev/null
alt=$(printf %s "$1$2" | sed 's|/|>|g')
cd "$sys_db/../choices"
2020-01-28 13:07:11 +00:00
[ -f "$alt" ] || [ -h "$alt" ] ||
2020-01-28 13:07:11 +00:00
die "Alternative '$1 $2' doesn't exist"
if [ -f "$2" ]; then
# Figure out which package owns the file we are going to
# swap for another package's.
#
# Print the full path to the manifest file which contains
# the match to our search.
pkg_owns=$(set +f; "$grep" -lFx "$2" "$sys_db/"*/manifest) ||:
# Extract the package name from the path above.
pkg_owns=${pkg_owns%/*}
pkg_owns=${pkg_owns##*/}
[ "$pkg_owns" ] ||
die "File '$2' exists on filesystem but isn't owned"
log "Swapping '$2' from '$pkg_owns' to '$1'"
# Convert the current owner to an alternative and rewrite
# its manifest file to reflect this.
cp -Pf "$2" "$pkg_owns>${alt#*>}"
2020-04-29 07:12:09 +00:00
sed "$(esc "$2" "$PWD/$pkg_owns>${alt#*>}")" \
2020-04-29 07:12:09 +00:00
"../installed/$pkg_owns/manifest" > "$mak_dir/.$1"
mv -f "$mak_dir/.$1" "../installed/$pkg_owns/manifest"
fi
# Convert the desired alternative to a real file and rewrite
# the manifest file to reflect this. The reverse of above.
2020-01-30 07:27:25 +00:00
mv -f "$alt" "$2"
2020-04-29 07:12:09 +00:00
sed "$(esc "$PWD/$alt" "$2")" \
"../installed/$1/manifest" > "$mak_dir/.$1"
mv -f "$mak_dir/.$1" "../installed/$1/manifest"
2020-01-28 13:07:11 +00:00
}
2020-04-22 06:18:12 +00:00
pkg_install_files() {
# Reverse the manifest file so that we start shallow and go
# deeper as we iterate over each item. This is needed so that
# directories are created going down the tree.
2020-04-22 14:51:42 +00:00
sort "$2/$pkg_db/${2##*/}/manifest" |
2020-04-22 16:35:17 +00:00
while read -r line; do
# Grab the octal permissions so that directory creation
# preserves permissions.
2020-05-01 16:26:36 +00:00
rwx=$(ls -ld "$2/$line") oct='' b='' o=0
2020-04-28 04:43:54 +00:00
2020-05-01 16:26:36 +00:00
# Convert the output of 'ls' (rwxrwx---) to octal. This is simply
2020-04-28 04:43:54 +00:00
# a 1-9 loop with the second digit being the value of the field.
for c in 14 22 31 44 52 61 74 82 91; do rwx=${rwx#?}
2020-05-01 16:26:36 +00:00
case $rwx in
2020-04-28 04:43:54 +00:00
[rwx]*): $((o+=${c#?})) ;;
[st]*): $((o+=1)) $((b+=4 / (${c%?}/3))) ;;
[ST]*): $((b+=1)) ;;
esac
[ "$((${c%?} % 3))" = 0 ] && oct=$oct$o o=0
done
# Copy files and create directories (preserving permissions),
# skipping anything located in /etc/.
#
# The 'test' will run with '-e' for no-overwrite and '-z'
# for overwrite.
case $line in /etc/*) ;;
2020-05-01 16:26:36 +00:00
*/)
2020-04-26 08:00:28 +00:00
# Skip directories if they already exist in the file system.
# (Think /usr/bin, /usr/lib, etc).
[ -d "$line" ] ||
2020-04-28 04:43:54 +00:00
install -o root -g root -m "$oct" -d "$KISS_ROOT/$line"
2020-04-26 08:00:28 +00:00
;;
2020-04-22 06:37:46 +00:00
*) test "$1" "$KISS_ROOT/$line" ||
2020-04-22 10:50:02 +00:00
2020-04-26 08:00:28 +00:00
# Treat symlinks differently as the 'install' command
# will resolve them (we don't want this).
2020-05-01 16:26:36 +00:00
if [ -h "$2/$line" ]; then
2020-04-26 08:00:28 +00:00
# Skip symlinks which already exist as directories.
# (Think baselayout being updated)
[ -d "$KISS_ROOT/$line" ] && continue
cp -fPp "$2/$line" "${line%/*}"
chown -h root:root "$KISS_ROOT/$line"
2020-04-22 16:35:17 +00:00
else
2020-04-28 04:43:54 +00:00
install -o root -g root -m "$b$oct" \
"$2/$line" "$KISS_ROOT/$line"
2020-04-22 16:35:17 +00:00
fi
2020-04-22 16:29:55 +00:00
esac
done
2020-04-22 06:18:12 +00:00
}
2020-03-25 10:21:10 +00:00
pkg_etc() {
[ -d "$tar_dir/$pkg_name/etc" ] || return 0
(cd "$tar_dir/$pkg_name"
# Create all directories beforehand.
find etc -type d | while read -r dir; do
mkdir -p "$KISS_ROOT/$dir"
done
# Handle files in /etc/ based on a 3-way checksum check.
find etc ! -type d | while read -r file; do
{ sum_new=$(sh256 "$file")
sum_sys=$(cd "$KISS_ROOT/"; sh256 "$file")
2020-03-25 10:21:10 +00:00
sum_old=$("$grep" "$file$" "$mak_dir/c"); } 2>/dev/null ||:
log "$pkg_name" "Doing 3-way handshake for $file"
printf '%s\n' "Previous: ${sum_old:-null}"
printf '%s\n' "System: ${sum_sys:-null}"
printf '%s\n' "New: ${sum_new:-null}"
# Use a case statement to easily compare three strings at
# the same time. Pretty nifty.
case ${sum_old:-null}${sum_sys:-null}${sum_new} in
# old = Y, sys = X, new = Y
"${sum_new}${sum_sys}${sum_old}")
log "Skipping $file"
continue
;;
# old = X, sys = X, new = X
# old = X, sys = Y, new = Y
# old = X, sys = X, new = Y
"${sum_old}${sum_old}${sum_old}"|\
"${sum_old:-null}${sum_sys}${sum_sys}"|\
"${sum_sys}${sum_old}"*)
log "Installing $file"
new=
;;
# All other cases.
*)
2020-04-28 15:40:59 +00:00
war "$pkg_name" "saving /$file as /$file.new"
2020-03-25 10:21:10 +00:00
new=.new
;;
esac
2020-04-22 17:08:47 +00:00
cp -fPp "$file" "$KISS_ROOT/${file}${new}"
2020-03-25 10:21:10 +00:00
chown root:root "$KISS_ROOT/${file}${new}" 2>/dev/null
done) ||:
}
2019-06-13 14:48:08 +00:00
pkg_remove() {
2019-06-29 20:38:35 +00:00
# Remove a package and all of its files. The '/etc' directory
# is handled differently and configuration files are *not*
# overwritten.
pkg_list "$1" >/dev/null || return
# Make sure that nothing depends on this package.
2020-03-26 10:15:05 +00:00
[ "$2" = check ] && {
log "$1" "Checking for reverse dependencies"
2020-01-29 13:03:18 +00:00
2020-03-26 10:15:05 +00:00
(cd "$sys_db"; set +f; "$grep" -lFx "$1" -- */depends) &&
die "$1" "Can't remove package, others depend on it"
}
2019-07-26 16:21:44 +00:00
# Block being able to abort the script with 'Ctrl+C' during removal.
# Removes all risk of the user aborting a package removal leaving
2019-07-04 15:32:53 +00:00
# an incomplete package installed.
trap '' INT
if [ -x "$sys_db/$1/pre-remove" ]; then
log "$1" "Running pre-remove script"
"$sys_db/$1/pre-remove" ||:
fi
while read -r file; do
# The file is in '/etc' skip it. This prevents the package
# manager from removing user edited configuration files.
[ "${file##/etc/*}" ] || continue
2019-06-26 16:27:36 +00:00
2020-04-14 14:48:36 +00:00
if [ -d "$KISS_ROOT/$file" ]; then
rmdir "$KISS_ROOT/$file" 2>/dev/null || continue
else
rm -f "$KISS_ROOT/$file"
fi
2020-03-26 10:15:05 +00:00
done < "$sys_db/$1/manifest" 2>/dev/null
2019-07-26 16:21:44 +00:00
# Reset 'trap' to its original value. Removal is done so
2019-07-04 15:32:53 +00:00
# we no longer need to block 'Ctrl+C'.
trap pkg_clean EXIT INT
2019-09-21 17:22:56 +00:00
log "$1" "Removed successfully"
2019-06-13 14:48:08 +00:00
}
2019-06-29 20:38:35 +00:00
pkg_install() {
2020-04-24 08:04:05 +00:00
# Install a built package tarball.
#
# Package installation works similarly to the method used by
# Slackware in some of their tooling. It's not the obvious
# solution to the problem, however it is the best solution
# at this given time.
#
# When an installation is an update to an existing package,
# instead of removing the old version first we do something
# different.
#
# The new version is installed overwriting any files which
# it has in common with the previously installed version of
# the package.
#
# A "diff" is then generated between the old and new versions
# and contains any files existing in the old version but not
# the new version.
#
# The package manager then goes and removes these files which
# leaves us with the new package version in the file system
# and all traces of the old version gone.
#
# For good measure the package manager will then install the
# new package an additional two times. Firstly to ensure that
# the above diff didn't contain anything incorrect. And
# Secondly to confirm that everything is sane.
#
# This is the better method as it is "seamless". An update to
# busybox won't create a window in which there is no access
# to all of its utilities to give an example.
2019-06-14 05:58:09 +00:00
2020-04-24 08:04:05 +00:00
# Install can also take the full path to a tarball.
# We don't need to check the repository if this is the case.
if [ -f "$1" ] && [ -z "${1%%*.tar.*}" ] ; then
2020-03-25 11:11:22 +00:00
tar_file=$1 pkg_name=${1##*/} pkg_name=${pkg_name%#*}
2019-06-29 20:38:35 +00:00
elif pkg_cache "$1" 2>/dev/null; then
pkg_name=$1
else
die "package has not been built, run 'kiss b pkg'"
fi
2019-06-29 20:38:35 +00:00
mkdir -p "$tar_dir/$pkg_name"
log "$pkg_name" "Extracting $tar_file"
2019-06-29 20:38:35 +00:00
# The tarball is extracted to a temporary directory where its
2020-04-22 05:41:59 +00:00
# contents are then "installed" to the filesystem.
#
# Running this step as soon as possible allows us to also check
# the validity of the tarball and bail out early if needed.
kiss: Various portability fixes. - Added POSIX shell implementation of the 'readlink' utility for use _only_ when the 'readlink' utility is not available. - Made tar usage more portable. All that is left now is the removal of --strip-components 1 for full (presumed) portability. - Swapped from sha256sum to shasum as it's more portable. This is still not a full solution. Here's a checklist of where we currently are: POSIX Core utilities (depends coreutils) - [x] sh (POSIX) - [x] find (POSIX) -type f, -type d, -exec {} [+;], -o, -print, ! - [x] ls (POSIX) -l, -d - [x] sed (POSIX) -n, s/<search>/<replace>/g, /<delete>/d - [x] grep (POSIX) -l, -F, -x, -f, -q, -v - [x] sort (POSIX) -r, -u, -k - [x] tee (POSIX) - [x] date (POSIX) - [x] mkdir (POSIX) -p - [x] rm (POSIX) -f, -r - [x] rmdir (POSIX) - [x] cp (POSIX) -f, -P, -p, -L, -R - [x] mv (POSIX) -f - [x] chown (POSIX) -h - [x] diff (POSIX) -U BSD utilities - [x] install (BSD, not POSIX) (still portable) -o, -g, -m, -d Misc - [x] readlink (NOT POSIX) (fallback shell implementation) - [x] su* (sudo, doas, su) (in order, optional) - [x] git (downloads from git) (must link to curl) Compiler/libc utilities (depends cc & libc) - [x] readelf (Part of compiler toolchain) (GNU, LLVM or elfutils) - [x] strip (Part of compiler toolchain) (GNU, LLVM or elfutils) - [x] ldd (Part of libc) Tarball compression - [ ] tar (must have --strip-components) (busybox, GNU, libarchive)) - [x] bzip2 (widely used) -d, -z - [x] xz (widely used) -d, -z, -c, -T - [x] gzip (widely used) -d, -6 - [x] zstd (optional) -d, -z, -c - [x] unzip (optional) - [ ] shasum (checksums) (NO standard. Portable across Linux/BSD)
2020-04-30 16:38:37 +00:00
(
cd "$tar_dir/$pkg_name"
decompress "$tar_file" | "$tar" xf -
kiss: Various portability fixes. - Added POSIX shell implementation of the 'readlink' utility for use _only_ when the 'readlink' utility is not available. - Made tar usage more portable. All that is left now is the removal of --strip-components 1 for full (presumed) portability. - Swapped from sha256sum to shasum as it's more portable. This is still not a full solution. Here's a checklist of where we currently are: POSIX Core utilities (depends coreutils) - [x] sh (POSIX) - [x] find (POSIX) -type f, -type d, -exec {} [+;], -o, -print, ! - [x] ls (POSIX) -l, -d - [x] sed (POSIX) -n, s/<search>/<replace>/g, /<delete>/d - [x] grep (POSIX) -l, -F, -x, -f, -q, -v - [x] sort (POSIX) -r, -u, -k - [x] tee (POSIX) - [x] date (POSIX) - [x] mkdir (POSIX) -p - [x] rm (POSIX) -f, -r - [x] rmdir (POSIX) - [x] cp (POSIX) -f, -P, -p, -L, -R - [x] mv (POSIX) -f - [x] chown (POSIX) -h - [x] diff (POSIX) -U BSD utilities - [x] install (BSD, not POSIX) (still portable) -o, -g, -m, -d Misc - [x] readlink (NOT POSIX) (fallback shell implementation) - [x] su* (sudo, doas, su) (in order, optional) - [x] git (downloads from git) (must link to curl) Compiler/libc utilities (depends cc & libc) - [x] readelf (Part of compiler toolchain) (GNU, LLVM or elfutils) - [x] strip (Part of compiler toolchain) (GNU, LLVM or elfutils) - [x] ldd (Part of libc) Tarball compression - [ ] tar (must have --strip-components) (busybox, GNU, libarchive)) - [x] bzip2 (widely used) -d, -z - [x] xz (widely used) -d, -z, -c, -T - [x] gzip (widely used) -d, -6 - [x] zstd (optional) -d, -z, -c - [x] unzip (optional) - [ ] shasum (checksums) (NO standard. Portable across Linux/BSD)
2020-04-30 16:38:37 +00:00
)
2019-07-04 14:43:10 +00:00
# Naively assume that the existence of a manifest file is all
# that determines a valid KISS package from an invalid one.
# This should be a fine assumption to make in 99.99% of cases.
[ -f "$tar_dir/$pkg_name/$pkg_db/$pkg_name/manifest" ] ||
die "'${tar_file##*/}' is not a valid KISS package"
# Ensure that the tarball's manifest is correct by checking that
# each file and directory inside of it actually exists.
[ "$KISS_FORCE" = 1 ] || {
log "$pkg_name" "Checking that manifest is valid"
2020-05-01 16:26:36 +00:00
while read -r line; do
2020-04-26 02:38:16 +00:00
[ -h "$tar_dir/$pkg_name/$line" ] ||
2020-05-01 16:26:36 +00:00
[ -e "$tar_dir/$pkg_name/$line" ] ||
die "File $line missing from tarball but mentioned in manifest"
done < "$tar_dir/$pkg_name/$pkg_db/$pkg_name/manifest"
log "$pkg_name" "Checking that all dependencies are installed"
2020-03-26 13:00:29 +00:00
[ -f "$tar_dir/$pkg_name/$pkg_db/$pkg_name/depends" ] &&
while read -r dep dep_type || [ "$dep" ]; do
[ "${dep##\#*}" ] || continue
[ "$dep_type" ] || pkg_list "$dep" >/dev/null ||
install_dep="$install_dep'$dep', "
done < "$tar_dir/$pkg_name/$pkg_db/$pkg_name/depends"
[ "$install_dep" ] && die "$1" "Package requires ${install_dep%, }"
}
2019-07-05 06:34:06 +00:00
2020-03-05 15:59:47 +00:00
run_hook pre-install "$pkg_name" "$tar_dir/$pkg_name"
pkg_conflicts "$pkg_name"
2020-01-28 12:07:08 +00:00
2019-09-21 17:22:56 +00:00
log "$pkg_name" "Installing package incrementally"
# Block being able to abort the script with Ctrl+C during installation.
# Removes all risk of the user aborting a package installation leaving
# an incomplete package installed.
trap '' INT
2019-07-21 08:14:34 +00:00
# If the package is already installed (and this is an upgrade) make a
# backup of the manifest and etcsums files.
2020-02-06 12:20:01 +00:00
cp -f "$sys_db/$pkg_name/manifest" "$mak_dir/m" 2>/dev/null ||:
cp -f "$sys_db/$pkg_name/etcsums" "$mak_dir/c" 2>/dev/null ||:
# Install the package's files by iterating over its manifest.
2020-04-22 06:37:46 +00:00
pkg_install_files -z "$tar_dir/$pkg_name" "Installing file"
# Handle /etc/ files in a special way (via a 3-way checksum) to determine
# how these files should be installed. Do we overwrite the existing file?
# Do we install it as $file.new to avoid deleting user configuration? etc.
#
# This is more or less similar to Arch Linux's Pacman with the user manually
# handling the .new files when and if they appear.
2020-03-25 10:21:10 +00:00
pkg_etc
2019-07-21 08:14:34 +00:00
# This is the aforementioned step removing any files from the old version of
# the package if the installation is an update. Each file type has to be
# specially handled to ensure no system breakage occurs.
#
# Files in /etc/ are skipped entirely as they'll be handled via a 3-way
# checksum system due to the nature of their existence.
2020-02-06 12:20:01 +00:00
"$grep" -vFxf "$sys_db/$pkg_name/manifest" "$mak_dir/m" 2>/dev/null |
2019-08-26 09:35:11 +00:00
2020-02-06 12:20:01 +00:00
while read -r file; do
file=$KISS_ROOT/$file
2019-09-10 12:38:26 +00:00
2020-02-06 12:20:01 +00:00
# Skip deleting some leftover files.
case $file in /etc/*) continue; esac
2019-08-26 09:35:11 +00:00
2020-02-06 12:20:01 +00:00
# Remove files.
2020-04-26 02:38:16 +00:00
if [ -f "$file" ] && [ ! -h "$file" ]; then
2020-02-06 12:20:01 +00:00
rm -f "$file"
2019-08-26 09:35:11 +00:00
2020-02-06 12:20:01 +00:00
# Remove file symlinks.
2020-04-26 02:38:16 +00:00
elif [ -h "$file" ] && [ ! -d "$file" ]; then
2020-04-28 05:39:59 +00:00
rm -f "$file"
2019-08-13 09:21:03 +00:00
2020-02-06 12:20:01 +00:00
# Skip directory symlinks.
2020-04-26 02:38:16 +00:00
elif [ -h "$file" ] && [ -d "$file" ]; then :
2020-02-06 12:20:01 +00:00
# Remove directories if empty.
elif [ -d "$file" ]; then
rmdir "$file" 2>/dev/null ||:
fi
done ||:
2019-06-29 20:38:35 +00:00
# Install the package's files a second time to fix any mess caused by the
# above removal of the previous version of the package.
2020-04-22 16:29:55 +00:00
log "$pkg_name" "Verifying installation"
2020-04-22 06:37:46 +00:00
pkg_install_files -e "$tar_dir/$pkg_name" " Checking file"
2019-07-22 08:01:37 +00:00
# Reset 'trap' to its original value. Installation is done so
# we no longer need to block 'Ctrl+C'.
trap pkg_clean EXIT INT
2019-09-20 16:53:58 +00:00
if [ -x "$sys_db/$pkg_name/post-install" ]; then
2019-09-21 17:22:56 +00:00
log "$pkg_name" "Running post-install script"
2020-01-30 07:27:25 +00:00
"$sys_db/$pkg_name/post-install" ||:
2019-09-20 16:53:58 +00:00
fi
2019-06-29 20:38:35 +00:00
2020-03-13 09:37:28 +00:00
run_hook post-install "$pkg_name" "$sys_db/$pkg_name"
2019-09-21 17:22:56 +00:00
log "$pkg_name" "Installed successfully"
2019-06-13 14:48:08 +00:00
}
2019-06-29 20:38:35 +00:00
pkg_updates() {
# Check all installed packages for updates. So long as the installed
# version and the version in the repositories differ, it's considered
# an update.
2019-08-19 17:15:50 +00:00
log "Updating repositories"
# Create a list of all repositories.
2019-09-20 14:54:12 +00:00
# See [1] at top of script.
# shellcheck disable=2046,2086
2020-04-20 09:14:25 +00:00
{ IFS=:; set -- $KISS_PATH; unset IFS; }
# Update each repository in '$KISS_PATH'. It is assumed that
# each repository is 'git' tracked.
2020-03-21 11:48:05 +00:00
for repo do
2019-08-14 09:58:14 +00:00
# Go to the root of the repository (if it exists).
2020-02-06 12:06:51 +00:00
cd "$repo"
2019-08-14 09:58:14 +00:00
cd "$(git rev-parse --show-toplevel 2>/dev/null)" 2>/dev/null ||:
2020-03-29 07:08:08 +00:00
[ -d .git ] || {
2019-10-04 10:47:25 +00:00
log "$repo" " "
2020-03-29 07:08:08 +00:00
printf '%s\n' "Not a git repository, skipping."
continue
}
[ "$(git remote 2>/dev/null)" ] || {
log "$repo" " "
printf '%s\n' "No remote, skipping."
continue
}
contains "$repos" "$PWD" || {
repos="$repos $PWD "
2019-08-14 09:58:14 +00:00
2019-10-04 10:47:25 +00:00
# Display a tick if signing is enabled for this
# repository.
case $(git config merge.verifySignatures) in
2020-02-06 12:06:51 +00:00
true) log "$PWD" "[signed ✓] " ;;
2020-04-24 08:04:05 +00:00
*) log "$PWD" " " ;;
2019-10-04 10:47:25 +00:00
esac
2020-02-10 18:02:45 +00:00
if [ -w "$PWD" ] && [ "$uid" != 0 ]; then
2020-02-08 08:50:31 +00:00
git fetch
git merge
else
2020-02-10 18:02:45 +00:00
[ "$uid" = 0 ] || log "$PWD" "Need root to update"
2020-01-30 15:24:57 +00:00
# Find out the owner of the repository and spawn
# git as this user below.
#
# This prevents 'git' from changing the original
# ownership of files and directories in the rare
# case that the repository is owned by a 3rd user.
(
2020-04-28 03:26:36 +00:00
read -r _ _ user _ <<-EOF || user=root
$(ls -ld "$PWD")
EOF
2020-01-30 15:24:57 +00:00
id -u "$user" >/dev/null 2>&1 ||
user=root
[ "$user" = root ] ||
2020-01-30 15:24:57 +00:00
log "Dropping permissions to $user for pull"
case $su in
2020-02-24 20:48:29 +00:00
su) "$su" -c "git fetch && git merge" "$user" ;;
2020-03-21 11:54:48 +00:00
*) "$su" -u "$user" git fetch
2020-02-24 20:48:29 +00:00
"$su" -u "$user" git merge
esac
2020-01-30 15:24:57 +00:00
)
fi
}
done
2019-08-19 17:15:50 +00:00
log "Checking for new package versions"
set +f
2019-09-10 12:38:26 +00:00
for pkg in "$sys_db/"*; do
pkg_name=${pkg##*/}
2019-06-29 20:38:35 +00:00
# Read version and release information from the installed packages
# and repository.
read -r db_ver db_rel < "$pkg/version"
read -r re_ver re_rel < "$(pkg_find "$pkg_name")/version"
2019-06-29 20:38:35 +00:00
# Compare installed packages to repository packages.
2019-07-11 06:14:17 +00:00
[ "$db_ver-$db_rel" != "$re_ver-$re_rel" ] && {
printf '%s\n' "$pkg_name $db_ver-$db_rel ==> $re_ver-$re_rel"
2019-09-10 09:35:25 +00:00
outdated="$outdated$pkg_name "
2019-07-11 06:14:17 +00:00
}
2019-06-13 14:48:08 +00:00
done
2019-07-11 06:14:17 +00:00
2020-02-06 11:55:01 +00:00
set -f
contains "$outdated" kiss && {
2019-09-21 17:22:56 +00:00
log "Detected package manager update"
log "The package manager will be updated first"
2020-02-18 19:28:35 +00:00
prompt
2020-01-30 07:27:25 +00:00
pkg_build kiss
args i kiss
2019-09-21 17:22:56 +00:00
log "Updated the package manager"
log "Re-run 'kiss update' to update your system"
exit 0
}
2019-07-11 06:14:17 +00:00
[ "$outdated" ] || {
2019-08-19 17:15:50 +00:00
log "Everything is up to date"
2019-07-11 06:14:17 +00:00
return
}
2019-09-10 09:35:25 +00:00
log "Packages to update: ${outdated% }"
2019-07-26 16:56:22 +00:00
# Build all packages requiring an update.
2019-09-20 14:54:12 +00:00
# See [1] at top of script.
# shellcheck disable=2046,2086
{
2020-03-25 11:11:22 +00:00
pkg_update=1
pkg_order $outdated
pkg_build $order
}
2019-08-24 09:18:08 +00:00
log "Updated all packages"
2019-06-13 14:48:08 +00:00
}
2019-06-29 20:38:35 +00:00
pkg_clean() {
# Clean up on exit or error. This removes everything related
# to the build.
2020-02-08 08:55:58 +00:00
[ "$KISS_DEBUG" != 1 ] || return
2020-01-27 09:10:53 +00:00
2020-03-26 09:30:30 +00:00
# Create a list containing the current invocation's temporary
# files and directories.
2020-05-08 08:12:27 +00:00
set +f -- "$mak_dir" "$pkg_dir" "$tar_dir" \
"$cac_dir/$pid-m" "$cac_dir/$pid-c"
2020-03-26 09:30:30 +00:00
# Go through the cache and add any entries which don't belong
2020-03-26 09:30:30 +00:00
# to a currently running kiss instance.
for dir in "$cac_dir/"[bep]*-[0-9]*; do
[ -e "/proc/${dir##*-}" ] || set -- "$@" "$dir"
done
2020-03-26 09:30:30 +00:00
rm -rf -- "$@"
2019-06-29 20:38:35 +00:00
}
2019-06-15 06:19:20 +00:00
2019-06-29 20:38:35 +00:00
args() {
2020-02-19 09:59:47 +00:00
# Parse script arguments manually. This is rather easy to do in
# our case since the first argument is always an "action" and
# the arguments that follow are all package names.
2019-08-19 18:45:19 +00:00
action=$1
2019-09-10 13:56:44 +00:00
# 'dash' exits on error here if 'shift' is used and there are zero
# arguments despite trapping the error ('|| :').
2020-04-20 05:59:13 +00:00
shift "$(($# ? 1 : 0))"
2019-08-19 18:45:19 +00:00
2019-10-01 19:34:34 +00:00
# Unless this is a search, sanitize the user's input. The call to
# 'pkg_find()' supports basic globbing, ensure input doesn't expand
# to anything except for when this behavior is needed.
#
# This handles the globbing characters '*', '!', '[' and ']' as per:
# https://pubs.opengroup.org/onlinepubs/009695399/utilities/xcu_chap02.html
2020-02-08 08:52:53 +00:00
[ "${action##[as]*}" ] &&
2020-04-21 10:05:28 +00:00
case "$*" in *\**|*\!*|*\[*|*\]*)
2020-02-03 09:02:04 +00:00
die "Arguments contain invalid characters: '!*[]'"
esac
2019-10-01 19:34:34 +00:00
2019-08-19 18:45:19 +00:00
# Parse some arguments earlier to remove the need to duplicate code.
case $action in
2020-04-15 08:39:03 +00:00
s|search)
2019-08-19 18:45:19 +00:00
[ "$1" ] || die "'kiss $action' requires an argument"
;;
2020-01-30 07:27:25 +00:00
a|alternatives)
# Rerun the script with 'su' if the user isn't root.
# Cheeky but 'su' can't be used on shell functions themselves.
2020-02-10 18:02:45 +00:00
[ -z "$1" ] || [ "$uid" = 0 ] || {
2020-01-30 12:42:29 +00:00
as_root kiss "$action" "$@"
return
}
2020-01-30 07:27:25 +00:00
;;
i|install|r|remove)
# Rerun the script with 'su' if the user isn't root.
# Cheeky but 'su' can't be used on shell functions themselves.
2020-02-10 18:02:45 +00:00
[ "$uid" = 0 ] || {
2020-01-30 12:42:29 +00:00
KISS_FORCE="$KISS_FORCE" as_root kiss "$action" "$@"
return
}
2020-01-30 07:27:25 +00:00
;;
2019-08-19 18:45:19 +00:00
esac
2019-06-29 20:38:35 +00:00
2020-04-15 08:39:03 +00:00
# Second early check to use $PWD in place of arguments.
2020-04-15 08:58:01 +00:00
[ "$1" ] || case $action in b|build|c|checksum|i|install|r|remove)
export KISS_PATH=${PWD%/*}:$KISS_PATH
2020-04-15 08:39:03 +00:00
set -- "${PWD##*/}"
esac
2019-06-29 20:38:35 +00:00
# Actions can be abbreviated to their first letter. This saves
2019-09-09 08:31:31 +00:00
# keystrokes once you memorize the commands.
2019-08-19 18:45:19 +00:00
case $action in
2020-01-28 12:16:01 +00:00
a|alternatives)
2020-01-28 18:33:54 +00:00
if [ "$1" = - ]; then
while read -r pkg path; do
pkg_swap "$pkg" "$path"
done
elif [ "$1" ]; then
2020-01-28 13:07:11 +00:00
pkg_swap "$@"
2020-01-28 12:29:15 +00:00
2020-01-28 12:24:37 +00:00
else
# Go over each alternative and format the file
# name for listing. (pkg_name>usr>bin>ls)
2020-03-22 14:26:08 +00:00
set +f; for pkg in "$sys_db/../choices"/*; do
2020-02-06 11:42:57 +00:00
printf '%s\n' "${pkg##*/}"
2020-03-22 14:26:08 +00:00
done | sed 's|>| /|; s|>|/|g; /\*/d'
2020-01-28 12:24:37 +00:00
fi
2020-01-28 12:16:01 +00:00
;;
2019-08-21 11:00:50 +00:00
c|checksum)
2020-03-21 11:48:05 +00:00
for pkg do pkg_lint "$pkg" c; done
for pkg do pkg_sources "$pkg" c; done
for pkg do
pkg_checksums "$pkg" | {
repo_dir=$(pkg_find "$pkg")
if [ -w "$repo_dir" ]; then
tee "$repo_dir/checksums"
else
log "$pkg" "Need permissions to generate checksums"
2020-04-28 03:26:36 +00:00
read -r _ _ user _ <<-EOF || user=root
$(ls -ld "$PWD")
EOF
user=$user as_root tee "$repo_dir/checksums"
fi
}
2019-06-29 20:38:35 +00:00
2019-09-21 17:22:56 +00:00
log "$pkg" "Generated checksums"
2019-07-21 11:21:47 +00:00
done
2019-06-29 20:38:35 +00:00
;;
2019-08-19 18:45:19 +00:00
i|install)
pkg_order "$@"
2019-09-15 06:31:57 +00:00
for pkg in $order; do pkg_install "$pkg"; done
2019-06-29 20:38:35 +00:00
;;
2019-08-19 18:45:19 +00:00
r|remove)
pkg_order "$@"
2020-03-26 12:53:03 +00:00
for pkg in $redro; do
2019-08-31 13:01:17 +00:00
pkg_remove "$pkg" "${KISS_FORCE:-check}"
done
2019-06-29 20:38:35 +00:00
;;
2020-04-18 06:56:21 +00:00
b|build) pkg_build "${@:?No packages installed}" ;;
2020-02-03 09:02:04 +00:00
l|list) pkg_list "$@" ;;
u|update) pkg_updates ;;
s|search) for pkg do pkg_find "$pkg" all; done ;;
2020-05-09 09:24:15 +00:00
v|version) printf '1.14.0\n' ;;
2019-06-29 20:38:35 +00:00
2019-08-19 18:45:19 +00:00
h|help|-h|--help|'')
2020-01-28 12:16:01 +00:00
log 'kiss [a|b|c|i|l|r|s|u|v] [pkg] [pkg] [pkg]'
log 'alternatives List and swap to alternatives'
log 'build Build a package'
log 'checksum Generate checksums'
log 'install Install a package'
log 'list List installed packages'
log 'remove Remove a package'
log 'search Search for a package'
log 'update Check for updates'
log 'version Package manager version
'
log "Installed extensions (kiss-* in \$PATH)"
set --
2020-05-08 15:48:16 +00:00
for path in $(KISS_PATH=$PATH pkg_find kiss-\* all -x); do
2020-04-20 08:07:48 +00:00
[ -x "$path" ] && set -- "${path#*/kiss-}" "$@"
max=$((${#1} > max ? ${#1} : max))
done
for path do
printf '\033[31;1m->\033[m %-*s ' "$max" "${path#*/kiss-}"
sed -n 's/^# *//;2p' "$(command -v "kiss-$path")"
done | sort -uk1 >&2
2019-06-29 20:38:35 +00:00
;;
2019-07-24 22:33:12 +00:00
*)
2020-05-08 15:48:16 +00:00
util=$(KISS_PATH=$PATH pkg_find "kiss-$action*" "" -x 2>/dev/null) ||
die "'kiss $action' is not a valid command"
"$util" "$@"
;;
2019-06-13 14:48:08 +00:00
esac
}
main() {
2020-03-21 11:29:56 +00:00
# Die here if the user has no set KISS_PATH. This is a rare occurance
# as the environment variable should always be defined.
[ "$KISS_PATH" ] || die "\$KISS_PATH needs to be set"
2019-07-19 14:37:25 +00:00
# Set the location to the repository and package database.
2019-09-10 12:38:26 +00:00
pkg_db=var/db/kiss/installed
2019-07-19 14:37:25 +00:00
2019-06-29 20:38:35 +00:00
# The PID of the current shell process is used to isolate directories
# to each specific KISS instance. This allows multiple package manager
# instances to be run at once. Store the value in another variable so
# that it doesn't change beneath us.
pid=${KISS_PID:-$$}
2019-06-13 15:11:59 +00:00
2020-03-26 10:21:57 +00:00
# Force the C locale to speed up things like 'grep' which disable unicode
# etc when this is set. We don't need unicode and a speed up is always
# welcome.
2020-04-20 08:07:48 +00:00
export LC_ALL=C
2020-03-26 10:21:57 +00:00
2019-06-29 20:38:35 +00:00
# Catch errors and ensure that build files and directories are cleaned
# up before we die. This occurs on 'Ctrl+C' as well as success and error.
2019-06-29 20:38:35 +00:00
trap pkg_clean EXIT INT
2019-06-13 14:48:08 +00:00
2020-01-14 09:59:30 +00:00
# Prefer GNU grep if installed as it is much much faster than busybox's
# implementation. Very much worth it if you value performance over
2020-02-06 11:31:47 +00:00
# POSIX correctness (grep quoted to avoid shellcheck false-positive).
grep=$(command -v ggrep) || grep='grep'
2020-01-14 09:59:30 +00:00
2020-02-04 23:33:24 +00:00
# Prefer libarchive tar or GNU tar if installed as they are much
# much faster than busybox's implementation. Very much worth it if
# you value performance.
2020-02-06 11:31:47 +00:00
tar=$(command -v bsdtar || command -v gtar) || tar=tar
2020-02-04 23:20:30 +00:00
# Figure out which 'sudo' command to use based on the user's choice or
# what is available on the system.
su=${KISS_SU:-$(command -v sudo || command -v doas)} || su=su
2020-01-28 08:08:15 +00:00
# Store the date and time of script invocation to be used as the name
# of the log files the package manager creates uring builds.
2020-01-30 11:43:30 +00:00
time=$(date '+%Y-%m-%d-%H:%M')
2020-01-28 08:08:15 +00:00
2020-02-10 18:02:45 +00:00
# Make note of the user's current ID to do root checks later on.
# This is used enough to warrant a place here.
uid=$(id -u)
# Make sure that the KISS_ROOT doesn't end with a '/'. This might
# break some operations.
KISS_ROOT=${KISS_ROOT%/}
2019-09-10 12:43:34 +00:00
# This allows for automatic setup of a KISS chroot and will
# do nothing on a normal system.
mkdir -p "${sys_db:=$KISS_ROOT/$pkg_db}" 2>/dev/null ||:
2019-07-03 13:35:14 +00:00
# Create the required temporary directories and set the variables
# which point to them.
2019-09-10 12:38:26 +00:00
mkdir -p "${cac_dir:=$KISS_ROOT${XDG_CACHE_HOME:-$HOME/.cache}/kiss}" \
2019-07-21 10:10:51 +00:00
"${mak_dir:=$cac_dir/build-$pid}" \
"${pkg_dir:=$cac_dir/pkg-$pid}" \
"${tar_dir:=$cac_dir/extract-$pid}" \
"${src_dir:=$cac_dir/sources}" \
2020-01-28 08:08:15 +00:00
"${log_dir:=$cac_dir/logs}" \
2020-02-19 22:57:12 +00:00
"${bin_dir:=$cac_dir/bin}"
2019-07-03 13:35:14 +00:00
2019-06-13 14:48:08 +00:00
args "$@"
}
main "$@"